function [retcode,errest,phis,newtoniter,energy,mu] = minimize(phis,contparams,alphainit,Hw,ev,diffpotential,energyfun,phirwfun,residualfun,newtonfun,errorfun,exact,singtol,tol,maxiterations,N,NH)
% local minimisation
newtoniter = 0;
errest = tol+1;
optalpha = alphainit;
phirw = feval(phirwfun,NH,phis,Hw);
[energy,penalty,r] = feval(energyfun,N,NH,phis,phirw,contparams,ev,diffpotential,-1);
while (errest > tol & newtoniter < maxiterations)
  newtoniter = newtoniter+1;
  % calculate the gradient (== residual)
  [R,Rpenalty] = feval(residualfun,N,NH,phis,phirw,contparams,Hw,ev,diffpotential,r);
  [dphis,initslope] = feval(newtonfun,NH,phis,phirw,contparams,Hw,ev,diffpotential,R,exact,singtol,Rpenalty);
  if (initslope > 0)
    error('Positve slope in the search direction.')
  end
  alpha = optalpha;
  penaltyold = penalty;
  [retcode,phis,phirw,penalty,lambda] = linesearch(N,NH,phis,dphis,initslope,penaltyold,alpha,energyfun,phirwfun,contparams,Hw,ev,diffpotential,r);
  if (retcode == 1) % not possible to find an acceptable steplength; try again with alphainit
    if (optalpha > alphainit)
      alpha = alphainit;
      [retcode,phis,phirw,penalty,lambda] = linesearch(N,NH,phis,dphis,initslope,penaltyold,alpha,energyfun,phirwfun,contparams,Hw,ev,diffpotential,r);
      if (retcode == 1) % not possible to find an acceptable steplength; stop the iteration and reduce contparams
        newtoniter = maxiterations;
        return
      end	
    end
  end
% an acceptable step was found  
  if (lambda == 1) % increase alpha
    optalpha = min((penalty-penaltyold)/initslope,0.99);
  else % decrease alpha
    optalpha = max(alphainit,min(lambda,alpha*0.75));
  end
  [energy,mu] = feval(energyfun,N,NH,phis,phirw,contparams,ev,diffpotential);  
  errest = feval(errorfun,N,NH,phis,mu);
end
if (errest > tol)
  retcode = 1;
end
