function [X,Y,V,lambda_fft] = initialise_2d_fft(M,a,potential,m,omega)
if (max(mod(M,2)) == 1)
  error('M(1) and M(2) should be even integers')
end
l = length(potential);
x = linspace(-a(1),a(1),M(1)+1);
x = x(1:M(1));
y = linspace(-a(2),a(2),M(2)+1);
y = y(1:M(2));
[X,Y] = meshgrid(x,y);
[lambda_x_fft,lambda_y_fft] = meshgrid((pi*[-M(1)/2:M(1)/2-1]/a(1)).^2/2,...
(pi*[-M(2)/2:M(2)/2-1]/a(2)).^2/2);
for i = 1:l
    lambda_fft{i} = -sqrt(-1)*(lambda_x_fft+lambda_y_fft);
    V{i} = feval(potential{i},X,Y,m(i),omega(i,:));
end

