function y = roundf(x,varargin)
%
% y = roundf(x)
%
% y = roundf(x,digits)
%
% round the number x to n digits. If n is omitted, n=1.
if (nargin == 2)
  n = varargin{1};
else
  n = 1;
end
absx = abs(x);
if (log10(absx) > 0)
  n = n-1;
end
power = -fix(log10(absx))+n;
y = sign(x)*round(absx*10^power)*10^(-power);
